/*****************************************************************
 * Copyright (c) ParaSoft Corporation 1991.  All rights reserved.*
 * THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF ParaSoft       *
 * The copyright notice above does not evidence any              *
 * actual or intended publication of such source code.           *
 *****************************************************************/

#include <stdio.h>
#include <ctype.h>

#include "yppexpor.h"
#include "typedef.h"
#include "u.h"

#define ID	1
#define ACT	2

#define fd_treec_max	5

typedef struct Rbody {
	int type;
	int tok;
	int num;
	char *act;
} Rbody;

#define MAXPROD		100
#define MAXRBODY	20

typedef struct Rule {
	int tok;
	int np;
	int *nrb;
	Rbody *rb[MAXPROD];
	char **act;
	int *sys_act;
} Rule;

typedef struct Decl {
	int ndecl;
	int *decl;
	int *num;
} Decl;

typedef struct Exte {
	int use_def;
	int node;
	char *add;
	int np;
} Exte;

/* symbol table entries */

extern char *symbol[], *Symbol[], *Lymbol[];
extern int type[];
extern Rule *R[];
extern Decl *D[];
extern Exte *E[];

extern int get_symbol ();
extern int get_Symbol ();

extern FILE *fd_treec [], *fd_treeh, *fd_tokens, *fd_output;

extern int tok;

char *get_lit_name();
char *to_symbol();
char *to_Symbol();
char *get_act();

extern char serr[];

Rule *copy_cR ();
Decl *creat_Decl ();

Exte *alloc_Exte ();

extern char yytext[];
